pipeline  {
	agent any
	
	tools {
        jdk 'OpenJDK11'
    }
    options {
        buildDiscarder(logRotator(numToKeepStr: '5'))
      	gitLabConnection('gitlab.com')
      	gitlabBuilds(builds: ['Jenkins Build', 'Release', 'Post-Build'])
    }
    triggers {
        gitlab(triggerOnPush: true, triggerOnMergeRequest: true, branchFilterType: 'All')
    }
	post {
      failure {
        updateGitlabCommitStatus name: 'Post-Build', state: 'failed'
      }
      success {
        updateGitlabCommitStatus name: 'Post-Build', state: 'success'
      }
    }
	
    stages {
        stage('Build') {
            steps {
                echo "I am building on ${env.BRANCH_NAME}"
                updateGitlabCommitStatus name: 'Jenkins Build', state: 'pending'
				sh "./gradlew clean build --info --stacktrace -Dmaven.repo.local=${WORKSPACE}/.m2"
				junit '**/generated/test-reports/**/*.xml'
				updateGitlabCommitStatus name: 'Jenkins Build', state: 'success'
		    }
		}
        stage('Master branch release') {
            when { 
            	branch 'master' 
            }
            steps {
	
                echo "I am building on ${env.BRANCH_NAME}"
                updateGitlabCommitStatus name: 'Release', state: 'pending'
				sh "./gradlew clean build release -Drelease.dir=$JENKINS_HOME/repo.gecko/release/playertour/ -x test -x testOSGi --info --stacktrace -Dmaven.repo.local=${WORKSPACE}/.m2"
                updateGitlabCommitStatus name: 'Release', state: 'success'
		    }
		}
        stage('Snapshot branch release') {
            when { 
            	branch 'develop'
            }
            steps  {
                echo "I am building on ${env.JOB_NAME}"
                updateGitlabCommitStatus name: 'Release', state: 'pending'
				sh "./gradlew release --info --stacktrace -Dmaven.repo.local=${WORKSPACE}/.m2"
                updateGitlabCommitStatus name: 'Release', state: 'success'
		    }
		}
		
    }

}
